/*------------------------------------------------------------------------
  Junction: Concurrent data structures in C++
  Copyright (c) 2016 Jeff Preshing

  Distributed under the Simplified BSD License.
  Original location: https://github.com/preshing/junction

  This software is distributed WITHOUT ANY WARRANTY; without even the
  implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  See the LICENSE file for more information.
------------------------------------------------------------------------*/

#include <junction/Core.h>
#include <junction/details/Linear.h>
#include <turf/Heap.h>

namespace junction {
namespace details {

TURF_TRACE_DEFINE_BEGIN(Linear, 22) // autogenerated by TidySource.py
TURF_TRACE_DEFINE("[find] called")
TURF_TRACE_DEFINE("[find] found existing cell")
TURF_TRACE_DEFINE("[insert] called")
TURF_TRACE_DEFINE("[insert] found existing cell")
TURF_TRACE_DEFINE("[insert] ran out of cellsRemaining")
TURF_TRACE_DEFINE("[insert] reserved cell")
TURF_TRACE_DEFINE("[insert] detected race to reserve cell")
TURF_TRACE_DEFINE("[insert] race reserved same hash")
TURF_TRACE_DEFINE("[beginTableMigration] called")
TURF_TRACE_DEFINE("[beginTableMigration] new migration already exists")
TURF_TRACE_DEFINE("[beginTableMigration] new migration already exists (double-checked)")
TURF_TRACE_DEFINE("[table] restarting valuesRemaining CAS loop")
TURF_TRACE_DEFINE("[table] valuesRemaining CAS failed")
TURF_TRACE_DEFINE("[migrateRange] empty cell already redirected")
TURF_TRACE_DEFINE("[migrateRange] race to insert key")
TURF_TRACE_DEFINE("[migrateRange] race to insert value")
TURF_TRACE_DEFINE("[migrateRange] racing update was erase")
TURF_TRACE_DEFINE("[migrateRange] race to update migrated value")
TURF_TRACE_DEFINE("[TableMigration::run] already ended")
TURF_TRACE_DEFINE("[TableMigration::run] detected end flag set")
TURF_TRACE_DEFINE("[TableMigration::run] out of migration units")
TURF_TRACE_DEFINE("[TableMigration::run] not the last worker")
TURF_TRACE_DEFINE_END(Linear, 22)

} // namespace details
} // namespace junction
